/*
 * (c) Copyright 2002 - 2005 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _APUI_DEFS_H_
#define _APUI_DEFS_H_

/* FIXME: change names, remove redundant, move some/most to apui.h */

#define FOR_IN_AND_OUT for (io = 0; io < 2; io++)
#define IN VCU_IN
#define OUT VCU_OUT

#define PATH_SEPARATOR_STR "/"
#define PATH_SEPARATOR_CHR '/'

#define SOUNDSPEED 343

#define VCU_VOLUME_MIN -48.0
#define VCU_VOLUME_MAX +48.0
#define VCU_TRIM_DELAY_RANGE 0.1
#define VCU_REVERB_DELAY_RANGE 0.5
#define VCU_DYNAMIC_RANGE +24.0
#define VCU_DISTANCE_MAX 100
#define VCU_EQ_COMPONENTS_MAX 32

#define VCU_FFTEQ_VOLUME_MIN -20.0
#define VCU_FFTEQ_VOLUME_MAX +20.0
#define VCU_FFTEQ_SMALLEST_BAND 5.0

#define VCU_MAX_STAGES 8

#define VCU_MAX_CHANNELS BFIR_MAX_OUTPUT_CHANNELS

#define VCU_MAX_CHANNEL_GROUPS 32
#define VCU_MAX_CHANNEL_MODES 32
#define VCU_MAX_EQ_MODES 32

#define VCU_MAX_EQ_PROGRAMS 256
#define VCU_MAX_XTC_PROGRAMS 16

#define VCU_BENCHMARK_MAX_SECONDS 24.0
#define VCU_BENCHMARK_MIN_SECONDS 0.5

#define VCU_REVERB_BALANCE_RANGE 24.0
#define VCU_REVERB_EARLY_LENGTH 0.050
#define VCU_REVERB_DIRECT_LENGTH 0.010

#define VCU_CUT_VOLUME_MAX -60.0
#define VCU_CUT_VOLUME_MIN -200.0

#define VCU_MIN_NORMAL_RT60 1.0

#define VCU_MUTE_GROUP_COUNT 8

#define ALMUSVCU_LOG "almusvcu.log"
#define VCU_LOG_ARCHIVE "vculogs.tgz" /* likely to be saved to 8+3 filename */
#define CONF_FILE_STATIC "almusvcu_static_config"
#define CONF_FILE_USER "almusvcu_user_config"
#define CONF_UIMODULES_MAX 128
#define CONF_DEVICES_MAX 8
#define CONF_SAMPLE_FORMATS_MAX 16
#define CONF_ALLOCATE_RAM_MIN 50
#define CONF_STORAGE_MIN_SIZE 10
#define CONF_MAX_XTC_PROGRAMS 64
#define CONF_MAX_EQ_PROGRAMS 256
#define CONF_MAX_FPROGREFS (BFIR_MAX_REVERB_PROGRAMS + CONF_MAX_XTC_PROGRAMS + \
                            CONF_MAX_EQ_PROGRAMS)
#define VCU_MAX_EQ_SIZE 524288
#define VCU_MAX_XTC_SIZE 524288

#define FILTERPRG_NAME_MAX 21
#define FILTERPRG_LONGNAME_MAX 256
#define FILTERPRG_RATES_MAX 4
#define VCU_VALID_RATES { 44100, 48000, 88200, 96000 }
#define FILTERPRG_CHANNELS_MAX 128
#define FILTERPRG_MD5SUM_MAX 33

/* BFIR_MAX_OUTPUT_CHANNELS must be divisable with 32 */
#define BFIR_MAX_OUTPUT_CHANNELS 64//FIXME: rename to BFIR_MAX_CHANNELS
#define BFIR_MAX_CHANNELS BFIR_MAX_OUTPUT_CHANNELS
#define BFIR_MAX_REVERB_PROGRAMS 256
#define BFIR_MIN_BLOCKSIZE_LOWLAT 64
#define BFIR_MIN_BLOCKSIZE_48000HZ 2048
#define BFIR_MAX_BLOCKSIZE_48000HZ 131072
#define BFIR_MIN_REVERB_LENGTH 16384
#define BFIR_MAX_PROCESSORS 16
#define BFIR_MAX_BLOCKS 1024
#define BFIR_MIN_BLOCKS 4

#define BFIR_BENCHMARK_N_BLOCK_SIZES (BFIR_MAX_BLOCKSIZE_48000HZ /             \
                                      BFIR_MIN_BLOCKSIZE_LOWLAT)
#define BFIR_BENCHMARK_INPUT_DEVICE "file"
#define BFIR_BENCHMARK_OUTPUT_DEVICE "file"
#define BFIR_BENCHMARK_INPUT_DEVICE_PARAMS "{ path: \"" ZERO_DEVICE "\"; }"
#define BFIR_BENCHMARK_OUTPUT_DEVICE_PARAMS "{ path: \"" NULL_DEVICE "\"; }"
#define BFIR_BENCHMARK_RTI_COUNTER 2

#define BFIR_DEBUG_LAST_BRUTEFIR_CONFIG "brutefir_last_config"
#define BFIR_DEBUG_BRUTEFIR_CONSOLE_OUTPUT "brutefir_console_output"
#define BFIR_DEBUG_BRUTEFIR_CLI_OUTPUT "brutefir_cli_output"
#define BFIR_DEBUG_BRUTEFIR_CLI_INPUT "brutefir_cli_input"

#define NULL_DEVICE "/dev/null"
#define ZERO_DEVICE "/dev/zero"

#endif
