/*
 * (c) Copyright 2002 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _BFIRMEM_H_
#define _BFIRMEM_H_

#include <inttypes.h>

#include "defs.h"

#define BFIR_MAX_SEGMENTS 64

struct memseg {
    int n_segments;
    int segids[BFIR_MAX_SEGMENTS];
    int segoffsets[BFIR_MAX_SEGMENTS];
    int seglengths[BFIR_MAX_SEGMENTS];
    uint8_t *segments[BFIR_MAX_SEGMENTS];
};

bool_t
bfirmem_init(int alloc_bytes);

void
bfirmem_finish(void);

bool_t
bfirmem_alloc(struct memseg *memseg,
	      int alloc_bytes,
	      int block_size);

void
bfirmem_free(struct memseg *memseg);

void
bfirmem_freeall(void);

int
bfirmem_bytes_left(void);

#endif



